C Author....: copyright (c) by Wolf-Rainer Novender 1989-2006
C Date......: JUL-1989, OCT-89, 30-NOV-1989 
C Remarks...: Programmsystem zum symbolischen Verwalten von Vektoren 
C             auf einer direkten Zugriffsdatei 
C Upgrades..: 07-06-90 Kommando POSDIR: stellt Directory zur Verfuegung 
C             17-04-91 Start und Endzeitpunkt beim Schreiben 
C             4-1-92   Sprung in IF-Block (label 1020,1100) behoben
C             1-3-06   COMPUTED GOTO ersetzt durch POS002, POS003, POS004
C                      und SELECT CASE 
C Vektortyp : 
C            3 = integer  (IBM/DEC: INTEGER*4) 
C            4 = real             ( REAL*4) 
C            5 = logical          ( LOGICAL*4) 
C            6 = double complex   ( COMPLEX*16) 
C            7 = complex          ( COMPLEX*8) 
C            8 = double precision ( REAL*8) 
C            9 = character/bytes  ( *1) 
 
 
      SUBROUTINE   POS000  (WCOMMD,LERROR) 
 
      PARAMETER (IDA=17,IRECL=2048,MAXNAM=51,NWR=16,ND06=6) 
 
      CHARACTER         WNAME(MAXNAM)*8,WRESRV(MAXNAM)*19, 
     *                  WSYMBL*(*), 
     *                  WCOMMD*(*),WARRAY*(*),WEOD*8, 
     *                  WBLANK*8,WDIR*8,wtimestamp*19
      INTEGER * 4       KTYP(MAXNAM),KLEN(MAXNAM),KADR(MAXNAM), 
     *                  IARRAY(*) 
 
      LOGICAL * 4       LFIRST,LERROR,LREC1,LARRAY(*)
      REAL * 4          SARRAY(*) 
      REAL * 8          DARRAY(*) 
      COMPLEX * 8       CSARAY(*) 
      COMPLEX * 16      CDARAY(*) 
 
      CHARACTER         W1NAM(*)*8,W1RES(*)*19 
      INTEGER           K1TYP(*),K1LEN(*),K1ADR(*) 
 
      DATA              LFIRST /.TRUE./, 
     *                  LREC1  /.FALSE./, 
     *                  WEOD   /'ZZZZZZZZ'/ 
     *                  WBLANK /'        '/ 
     *                  WDIR   /'DIRECTOR'/ 
      DATA              version /2.2/ 
 
      lerror = .true. 
      call pos001 (wtimestamp)

C Unit open?
 
      if (lfirst) then 
         call pos002 (ida,iostat,irecl,version)
         if (iostat .ne. 0) go to 9999
         lfirst=.false.
      end if
 
C Initialisierung der DA-Datei: 
 
      if (wcommd .eq. 'INITIAL') then 
         wname(1) = wdir 
         ktyp(1)  = 0 
         klen(1)  = 0 
         kadr(1)  = 1 
         wresrv(1)= wtimestamp
         wname(2) = weod 
         ktyp(2)  = 0 
         klen(2)  = 0 
         kadr(2)  = 2 
         wresrv(2)= ' ' 
         do i=3,maxnam 
            wname(i) = ' ' 
            ktyp(i)  = 0 
            klen(i)  = 0 
            kadr(i)  = 0 
            wresrv(i)= ' ' 
         end do

C write 'toc' (1rst record):

         call pos004 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
         if (iostat .ne. 0) go to 9999
         lerror = .false. 
         go to 9999 
      end if
       
C Inhaltsverzeichnis: 
 
      if (wcommd .eq. 'DIRECTORY') then
         if (.not. lrec1) then
            call pos003 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
            if (iostat .ne. 0) go to 9999
            lrec1=.true.
         end if 
         write (nwr,1161) version
 1161    format 
     *       ('0directory of direct access file - POS version ',f3.1,/, 
     *       '0 no. symbol_name type length address   last access'/) 
         do i=1,maxnam 
            write(nwr,1162) i,wname(i),ktyp(i),klen(i),kadr(i),wresrv(i)
 1162       format (' ',i4,1x,a10,1x,i3,1x,i6,1x,i7,4x,a) 
            if (wname(i) .eq. weod) then 
               write (nwr,'(//)') 
               lerror = .false. 
               go to 9999 
            end if 
         end do
         write (nd06,'(''0pos000 - DIRECTORY - is full!'')') 
         go to 9999 
      end if

C dummy keywords in order to get pos000 linked correctly
 
      if (wcommd .eq. 'OPEN' .or. wcommd .eq. 'CLOSE') then 
         lerror = .false. 
         go to 9999 
      end if 
 
      write (nd06,'(''0pos000 - '', 
     * ''illegal keyword, wcommd="'', a, ''"'')') wcommd 
      go to 9999 
 
C ================ Vektoren schreiben: ================================
 
      ENTRY  POSWI4  (WSYMBL,IARRAY,NLEN,LERROR)  
      IBLOCK = IRECL / 4 
      JOTTYP = 3 
      GO TO 2000 
 
      ENTRY  POSWR4  (WSYMBL,SARRAY,NLEN,LERROR)
      IBLOCK = IRECL / 4 
      JOTTYP = 4 
      GO TO 2000 
 
      ENTRY  POSWL4  (WSYMBL,LARRAY,NLEN,LERROR) 
      IBLOCK = IRECL / 4 
      JOTTYP = 5 
      GO TO 2000 
 
      ENTRY  POSWC6  (WSYMBL,CDARAY,NLEN,LERROR) 
      IBLOCK = IRECL / 16 
      JOTTYP = 6 
      GO TO 2000 
 
      ENTRY  POSWC8  (WSYMBL,CSARAY,NLEN,LERROR) 
      IBLOCK = IRECL / 8 
      JOTTYP = 7 
      GO TO 2000 
 
      ENTRY  POSWR8  (WSYMBL,DARRAY,NLEN,LERROR) 
      IBLOCK = IRECL / 8 
      JOTTYP = 8 
      GO TO 2000 
 
      ENTRY  POSWC1  (WSYMBL,WARRAY,NLEN,LERROR) 
      IBLOCK = IRECL 
      JOTTYP = 9 
      GO TO 2000 
 
 2000 continue 

      lerror = .true. 
      call pos001 (wtimestamp)
 
      if (wsymbl .eq. wblank .or. 
     *    wsymbl .eq. wdir .or. 
     *    wsymbl .eq. weod) then 
          write (nd06,'(''0poswxx - '', 
     *    ''illegal symbol name, wsymbl="'',a,''"'')') wsymbl 
          go to 9999 
      end if 

C DA opened?
 
      if (lfirst) then 
         call pos002 (ida,iostat,irecl,version)
         if (iostat .ne. 0) go to 9999
         lfirst=.false.
      end if
 
C retrieve 'toc' (1st record)

      if (.not. lrec1) then
         call pos003 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
         if (iostat .ne. 0) go to 9999
         lrec1=.true.
      end if 
 
C Einfgen: 
C           - falls Name noch nicht in der Tabelle (anstelle WEOD) 
C           - falls freier Platz ('  ') und gro genug 
C           - falls Platz mit gleichem Namen und gro genug 
 
      do i=1,maxnam-1 
C ans Ende anfgen:
         IF (WNAME(I).EQ.WEOD) GO TO 2050
C an freien Platz einfgen:
         IF ((WNAME(I).EQ.WBLANK) .AND. 
     *      (NLEN.LE.(KADR(I+1)-KADR(I))*IBLOCK)) GO TO 2050 
C Platz mit gleichem Namen berschreiben:
         IF ((WNAME(I).EQ.WSYMBL) .AND. 
     *      (NLEN.LE.(KADR(I+1)-KADR(I))*IBLOCK)) GO TO 2050 
         IF ((WNAME(I).EQ.WSYMBL) .AND. 
     *      (NLEN.GT.(KADR(I+1)-KADR(I))*IBLOCK)) THEN 
            WRITE (ND06,'(''0POSWXX - "'',A,''" already exists,'', 
     *       '' but file space too small !!!'')') WSYMBL 
            GO TO 9999 
         END IF 
      end do
      write (nd06,'(''0poswxx - directory overflow'')')
      go to 9999 
 
 2050 CONTINUE 
 
      NRECNO = KADR(I) 
      NREST = NLEN 
      IXA = 1 
 2055 IXE = MIN(NREST,IBLOCK) - 1 + IXA 

      select case (jottyp) 
         case (3)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            (iarray(ix),ix=ixa,ixe) 
         case (4)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            (sarray(ix),ix=ixa,ixe)
         case (5)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            (larray(ix),ix=ixa,ixe) 
         case (6)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            (cdaray(ix),ix=ixa,ixe) 
         case (7)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            (csaray(ix),ix=ixa,ixe) 
         case (8)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            (darray(ix),ix=ixa,ixe) 
         case (9)
            write (unit=ida,rec=nrecno,iostat=iostat)
     *            warray(ixa:ixe) 
         case default 
            print *,'poswxx: program error; jottyp=', jottyp 
            go to 9999 
      end select

      if (iostat .ne. 0) then 
         write (nd06,'(''0poswxx - '', 
     *     ''"write" error da file, iostat='',i7,'' ,jottyp='',i7)') 
     *     iostat,jottyp 
         go to 9999 
      end if 
 
      NRECNO = NRECNO + 1 
      IF (NREST.GT.IBLOCK) THEN 
         NREST = NREST - IBLOCK 
         IXA = IXA + IBLOCK 
         GO TO 2055 
      END IF 
 
      IF (WNAME(I) .EQ. WEOD) THEN 
         WNAME(I+1)  = WEOD 
         KTYP(I+1)   = 0 
         KLEN(I+1)   = 0 
         KADR(I+1)   = NRECNO 
         WRESRV(I+1) = ' '
      END IF 
 
      WNAME(I)   = WSYMBL 
      KTYP(I)    = JOTTYP 
      KLEN(I)    = NLEN 
      WRESRV(I)  = wtimestamp
 
C write 'toc' (1rst record):

      call pos004 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
      if (iostat .ne. 0) go to 9999
      lerror = .false. 
      go to 9999 
 
C ==================== Vektoren lesen: ================================
 
      ENTRY  POSRI4  (WSYMBL,IARRAY,NLEN,LERROR) 
      IBLOCK = IRECL / 4 
      JOTTYP = 3 
      GO TO 3000 
 
      ENTRY  POSRR4  (WSYMBL,SARRAY,NLEN,LERROR) 
      IBLOCK = IRECL / 4 
      JOTTYP = 4 
      GO TO 3000 
 
      ENTRY  POSRL4  (WSYMBL,LARRAY,NLEN,LERROR) 
      IBLOCK = IRECL / 4 
      JOTTYP = 5 
      GO TO 3000 
 
      ENTRY  POSRC6  (WSYMBL,CDARAY,NLEN,LERROR) 
      IBLOCK = IRECL / 16 
      JOTTYP = 6 
      GO TO 3000 
 
      ENTRY  POSRC8  (WSYMBL,CSARAY,NLEN,LERROR) 
      IBLOCK = IRECL / 8 
      JOTTYP = 7 
      GO TO 3000 
 
      ENTRY  POSRR8  (WSYMBL,DARRAY,NLEN,LERROR) 
      IBLOCK = IRECL / 8 
      JOTTYP = 8 
      GO TO 3000 
 
      ENTRY  POSRC1  (WSYMBL,WARRAY,NLEN,LERROR) 
      IBLOCK = IRECL 
      JOTTYP = 9 
      GO TO 3000 
 
 3000 CONTINUE 

      lerror = .true. 
      if (wsymbl .eq. wblank .or. 
     *    wsymbl .eq. wdir .or. 
     *    wsymbl .eq. weod) then 
          write (nd06,'(''0posrxx - '', 
     *     ''illegal symbolic name, wsymbl="'', a, ''"'')') wsymbl 
          go to 9999 
      end if 
 
C Unit open?
 
      if (lfirst) then 
         call pos002 (ida,iostat,irecl,version)
         if (iostat .ne. 0) go to 9999
         lfirst=.false.
      end if

C retrieve 'toc' (1st record)

      if (.not. lrec1) then
         call pos003 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
         if (iostat .ne. 0) go to 9999
         lrec1=.true.
      end if 

C 'toc' lookup: 

      do i=1,maxnam-1 
         if (wname(i).eq.wsymbl) go to 3050
      end do
      write (nd06,'(''0posrxx - '', 
     * ''symbol does not exist, wsymbl="'',a,''"'')') wsymbl 
      go to 9999 

 3050 continue
 
      if (klen(i).gt.nlen) then 
         write (nd06,'(''0posrxx - '', 
     *   ''symbol "'',a,''" excceeds limits, klen(i)='', 
     *   i10,'', nlen='',i10)') 
     *   wsymbl,klen(i),nlen 
         go to 9999 
      end if 
      IF (KTYP(I).NE.JOTTYP) THEN 
         WRITE (ND06,'(''0POSRXX - '', 
     *   ''illegal read CALL of symbol "'',A, 
     *   ''", KTYP(I)='',I3,'', JOTTYP='',I3)') 
     *   WSYMBL,KTYP(I),JOTTYP 
         GO TO 9999 
      END IF 
 
 
      NRECNO = KADR(I) 
      NLEN = KLEN(I) 
      NREST = NLEN 
      IXA = 1 
 3055 IXE = MIN(NREST,IBLOCK) - 1 + IXA 
 
      select case (jottyp)
         case (3)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           (IARRAY(IX),IX=IXA,IXE) 
         case (4)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           (SARRAY(IX),IX=IXA,IXE) 
         case (5)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           (LARRAY(IX),IX=IXA,IXE) 
         case (6)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           (CDARAY(IX),IX=IXA,IXE) 
         case (7)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           (CSARAY(IX),IX=IXA,IXE) 
         case (8)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           (DARRAY(IX),IX=IXA,IXE) 
         case (9)
            READ (UNIT=IDA,REC=NRECNO,IOSTAT=IOSTAT)
     *           WARRAY(IXA:IXE) 
         case default                      
            print *,'posrxx: program error; jottyp=', jottyp 
            go to 9999 
      end select

      if (iostat .ne. 0) then 
         write (nd06,'(''0posrxx - '', 
     *   ''"read" error da file, iostat='',i7,'' ,jottyp='',i3)') 
     *     iostat,jottyp 
         go to 9999 
      end if 
 
      NRECNO = NRECNO + 1 
      IF (NREST.GT.IBLOCK) THEN 
         NREST = NREST - IBLOCK 
         IXA = IXA + IBLOCK 
         GO TO 3055 
      END IF 
 
      lerror = .false. 
      go to 9999 
 
C  =================== Vektoren lschen: ==============================
 
      ENTRY  POSDEL  (WSYMBL,LERROR) 
 
      LERROR = .TRUE. 
 
      IF (WSYMBL.EQ.WBLANK.OR.WSYMBL.EQ.WDIR .OR. WSYMBL.EQ.WEOD) THEN 
         WRITE (ND06,'(''0POSDEL - '', 
     *   ''illegal symbol name, WSYMBL="'',A,''"'')') WSYMBL 
         GO TO 9999 
      END IF  
 
C Unit open?
 
      if (lfirst) then 
         call pos002 (ida,iostat,irecl,version)
         if (iostat .ne. 0) go to 9999
         lfirst=.false.
      end if

C retrieve 'toc' (1st record)

      if (.not. lrec1) then
         call pos003 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
         if (iostat .ne. 0) go to 9999
         lrec1=.true.
      end if 
 
      do i=1,maxnam-1 
         if (wname(i) .eq. wsymbl) go to 4030 
      end do
      write (nd06,'(''0posdel - "'',a,''" not found'')') wsymbl 
      go to 9999 
 
 4030 WNAME(I) = WBLANK 
      KTYP(I) = 0 
      KLEN(I) = 0 
      WRESRV(I) = ' '
 
C write 'toc' (1rst record):

      call pos004 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
      if (iostat .ne. 0) go to 9999
      lerror = .false. 
 4060 format ('POSWDEL - ',i3)
      print 4060,i
      go to 9999 
 
C =============== Directory zur Verfuegung stellen: ====================
 
      entry  posdir (w1nam,k1typ,k1len,k1adr,w1res,maxdir,lerror) 
 
      lerror = .true. 
      if (maxdir.lt.maxnam) then 
         write (nd06,'(''0posdir - new directory too small'')') 
         write (nd06,'(''0posdir - '', 
     *    ''maxdir (new) ='',i10,'', maxnam (old) ='',i10)') 
     *    maxdir,maxnam 
         go to 9999 
      end if 
      maxdir = maxnam 

C Unit open?
 
      if (lfirst) then 
         call pos002 (ida,iostat,irecl,version)
         if (iostat .ne. 0) go to 9999
         lfirst=.false.
      end if

C retrieve 'toc' (1st record)

      if (.not. lrec1) then
         call pos003 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)
         if (iostat .ne. 0) go to 9999
         lrec1=.true.
      end if 
 
      do i=1,maxnam 
         w1nam(i)=wname(i) 
         w1res(i)=wresrv(i) 
         k1typ(i)=ktyp(i) 
         k1len(i)=klen(i) 
         k1adr(i)=kadr(i) 
      end do 
      lerror = .false. 
      go to 9999 
 
 9999 RETURN 
 
      END 
C =====================================================================
C =====================================================================
      subroutine pos001 (wstamp)

      character  wstamp*(*),wdatum*10,wzeit*10

      call qqqdte (wdatum) 
      call qqqclk (wzeit) 
      write (wstamp,'(a,"/",a)') wdatum,wzeit(1:8)
c     *       wdatum(1:2),wdatum(4:5),wdatum(9:10),
c     *       wzeit(1:2),wzeit(4:5),wzeit(7:8)

      return

      end

      subroutine pos002 (ida,iostat,irecl,version)

C opens/ initializes DA

        character       wpname*8 /'POS002'/

C   The information below is culled from the definition of `F_err' in
C   `f/runtime/libI77/err.c' in the `g77' source tree.

C    100: "error in format"
C    101: "illegal unit number"
C    102: "formatted io not allowed"
C    103: "unformatted io not allowed"
C    104: "direct io not allowed"
C    105: "sequential io not allowed"
C    106: "can't backspace file"
C    107: "null file name"
C    108: "can't stat file"
C    109: "unit not connected"
C    110: "off end of record"
C    111: "truncation failed in endfile"
C    112: "incomprehensible list input"
C    113: "out of free space"
C    114: "unit not connected"
C    115: "read unexpected character"
C    116: "bad logical input field"
C    117: "bad variable type"
C    118: "bad namelist name"
C    119: "variable not in namelist"
C    120: "no end record"
C    121: "variable count incorrect"
C    122: "subscript for scalar variable"
C    123: "invalid array section"
C    124: "substring out of bounds"
C    125: "subscript out of bounds"
C    126: "can't read file"
C    127: "can't write file"
C    128: "'new' file exists"
C    129: "can't append to file"
C    130: "non-positive record number"
C    131: "I/O started while already doing I/O"

      open (unit=ida,iostat=iostat,
     *         status='unknown',
     *         form='unformatted',
     *         recl=irecl,
     *         access='direct',
     *         file='dirac.dat')

    1 format (a,'- POS Version',f5.2,'; unit=',i2,'; recl=',i5)
      print 1,wpname,version,ida,irecl
      if (iostat .ne. 0) 
     * print *,'pos002: open error - iunit=',ida,', - iostat=',iostat
     
      return

      end
      
      subroutine pos003 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam)

C reads 1st record (table of content)  of DA

      integer*4   ktyp(maxnam),klen(maxnam),kadr(maxnam)      
      character   wname(maxnam)*8, wresrv(maxnam)*19

      read (unit=ida,rec=1,iostat=iostat)
     *                  wname,ktyp,klen,kadr,wresrv 
      if (iostat .ne. 0)
     * print *,'pos003: read error - iunit=',ida,', - iostat=',iostat

      return

      end

      subroutine pos004 (ida,iostat,wname,ktyp,klen,kadr,wresrv,maxnam) 
 
C writes 1st record of DA (table of content)

      integer*4   ktyp(maxnam),klen(maxnam),kadr(maxnam)      
      character   wname(maxnam)*8, wresrv(maxnam)*19
 
      write (unit=ida,rec=1,iostat=iostat) 
     *                  wname,ktyp,klen,kadr,wresrv 
      if (iostat .ne. 0)
     * print *,'pos004: write error - iunit=',ida,', - iostat=',iostat

      return

      end
